#include "ot4xb.ch"
#include "dll.ch"
#include "Appevent.ch"
// ---------------------------------------------------------------------------
#define WM_ERASEBKGND                   0x0014
#define WM_NOTIFY                       0x004E
#define GWL_WNDPROC         dwminus( 4)
#define GWL_USERDATA        dwminus(21)
#define NM_CUSTOMDRAW       dwminus(12)
// ---------------------------------------------------------------------------
#define     GA_PARENT       1
// ---------------------------------------------------------------------------
#define TVIF_TEXT               0x0001
#define TVIF_IMAGE              0x0002
#define TVIF_PARAM              0x0004
#define TVIF_STATE              0x0008
#define TVIF_HANDLE             0x0010
#define TVIF_SELECTEDIMAGE      0x0020
#define TVIF_CHILDREN           0x0040
#define TVIF_INTEGRAL           0x0080
// ---------------------------------------------------------------------------
#define TVIS_SELECTED           0x0002
#define TVIS_EXPANDED           0x0020
// ---------------------------------------------------------------------------
#define CDDS_PREPAINT       0x00000001
#define CDDS_POSTPAINT      0x00000002
#define CDDS_PREERASE       0x00000003
#define CDDS_POSTERASE      0x00000004
#define CDDS_ITEM           0x00010000
#define CDDS_ITEMPREPAINT   nOr(CDDS_ITEM , CDDS_PREPAINT)
#define CDDS_ITEMPOSTPAINT  nOr(CDDS_ITEM , CDDS_POSTPAINT)
#define CDDS_ITEMPREERASE   nOr(CDDS_ITEM , CDDS_PREERASE)
#define CDDS_ITEMPOSTERASE  nOr(CDDS_ITEM , CDDS_POSTERASE)
#define CDDS_SUBITEM        0x00020000
// ---------------------------------------------------------------------------
#define CDRF_DODEFAULT          0
#define CDRF_NEWFONT            0x00000002
#define CDRF_SKIPDEFAULT        0x00000004
#define CDRF_NOTIFYPOSTPAINT    0x00000010
#define CDRF_NOTIFYITEMDRAW     0x00000020
#define CDRF_NOTIFYSUBITEMDRAW  0x00000020
#define CDRF_NOTIFYPOSTERASE    0x00000040
// ---------------------------------------------------------------------------
#define CDIS_SELECTED       0x0001
#define CDIS_GRAYED         0x0002
#define CDIS_DISABLED       0x0004
#define CDIS_CHECKED        0x0008
#define CDIS_FOCUS          0x0010
#define CDIS_DEFAULT        0x0020
#define CDIS_HOT            0x0040
#define CDIS_MARKED         0x0080
// ---------------------------------------------------------------------------
#define TV_FIRST                0x1100      // TreeView messages
#define TVM_GETITEMRECT         (TV_FIRST + 4)
#define TVM_GETINDENT           (TV_FIRST + 6)
#define TVM_GETITEM             (TV_FIRST + 12)
//-------------------------------------------------------------------------------------------------------------------------

#define DFC_CAPTION             1
#define DFC_MENU                2
#define DFC_SCROLL              3
#define DFC_BUTTON              4
#define DFC_POPUPMENU           5
#define DFCS_CAPTIONCLOSE       0x0000
#define DFCS_CAPTIONMIN         0x0001
#define DFCS_CAPTIONMAX         0x0002
#define DFCS_CAPTIONRESTORE     0x0003
#define DFCS_CAPTIONHELP        0x0004
#define DFCS_MENUARROW          0x0000
#define DFCS_MENUCHECK          0x0001
#define DFCS_MENUBULLET         0x0002
#define DFCS_MENUARROWRIGHT     0x0004
#define DFCS_SCROLLUP           0x0000
#define DFCS_SCROLLDOWN         0x0001
#define DFCS_SCROLLLEFT         0x0002
#define DFCS_SCROLLRIGHT        0x0003
#define DFCS_SCROLLCOMBOBOX     0x0005
#define DFCS_SCROLLSIZEGRIP     0x0008
#define DFCS_SCROLLSIZEGRIPRIGHT 0x0010
#define DFCS_BUTTONCHECK        0x0000
#define DFCS_BUTTONRADIOIMAGE   0x0001
#define DFCS_BUTTONRADIOMASK    0x0002
#define DFCS_BUTTONRADIO        0x0004
#define DFCS_BUTTON3STATE       0x0008
#define DFCS_BUTTONPUSH         0x0010

#define DFCS_INACTIVE           0x0100
#define DFCS_PUSHED             0x0200
#define DFCS_CHECKED            0x0400

#define DFCS_TRANSPARENT        0x0800
#define DFCS_HOT                0x1000

#define DFCS_ADJUSTRECT         0x2000
#define DFCS_FLAT               0x4000
#define DFCS_MONO               0x8000

// ---------------------------------------------------------------------------
// Function Pointers from DLLs
static _fpSelectObject_         := 0
static _fpExtTextOut_           := 0
static _fpDrawFrameControl_     := 0
static _fpSetBkMode_            := 0
static _fpSetTextColor_         := 0
static _fpSendMessage_          := 0
static _fpGetAncestor_          := 0
static _fpGetClientRect_        := 0
static _fpLoadImage_            := 0
static _fpDeleteObject_         := 0
static _fpCreatePatternBrush_   := 0
static _fpFillRect_             := 0
static _fpSetWindowLong_        := 0
static _fpGetWindowLong_        := 0
static _fpCallWindowProc_       := 0
// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------
proc appsys() ; return
// ---------------------------------------------------------------------------
proc main()
local nEvent,oSle,mp1 := NIL,mp2 := NIL, oXbp := NIL
local oDlg,oDa,oTree,oItem

   oDlg         := XbpDialog():new( ,, {50,30}, {550,550} )
   oDlg:title   := "Subclasing XbpTreeView"
   oDlg:maxButton := oDlg:MinButton := oDlg:TaskList := .T.
   oDlg:create()
   SetAppWindow(oDlg)

   oDa := oDlg:drawingArea

   oTree := CustomTree():new(oDa,, {0,0}, {500,500} )
   oTree:hasLines   := .T.
   oTree:hasButtons := .T.
   oTree:create()




   oItem := oTree:RootItem:addItem( "This is the First  Item" )
      oItem:addItem( "This is the First  Child Item" )
      oItem:addItem( "This is the Second Child Item" )
      oItem:addItem( "This is the Third  Child Item" )
   oItem := oTree:RootItem:addItem( "This is the Second Item" )
      oItem:addItem( "This is the First  Child Item" )
      oItem:addItem( "This is the Second Child Item" )
      oItem:addItem( "This is the Third  Child Item" )
   oItem := oTree:RootItem:addItem( "This is the Third  Item" )
      oItem:addItem( "This is the First  Child Item" )
      oItem:addItem( "This is the Second Child Item" )
      oItem:addItem( "This is the Third  Child Item" )

   nEvent := 0
   while nEvent != xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent( nEvent, mp1, mp2 )
   end
return
// ---------------------------------------------------------------------------
init proc _loadDllFuncs_()
local hGdi  := DllLoad("gdi32.dll")
local hUser := GetHUser32()

_fpSelectObject_        := nGetProcaddress(hGdi  , "SelectObject"       )
_fpExtTextOut_          := nGetProcAddress(hGdi  , "ExtTextOutA"        )
_fpSetBkMode_           := nGetProcAddress(hGdi  , "SetBkMode"          )
_fpSetTextColor_        := nGetProcAddress(hGdi  , "SetTextColor"       )
_fpCreatePatternBrush_  := nGetProcAddress(hGdi  , "CreatePatternBrush" )

_fpDrawFrameControl_    := nGetProcAddress(hUser , "DrawFrameControl"   )
_fpSendMessage_         := nGetProcAddress(hUser , "SendMessageA"       )
_fpGetAncestor_         := nGetProcAddress(hUser , "GetAncestor"        )
_fpGetClientRect_       := nGetProcAddress(hUser , "GetClientRect"      )
_fpLoadImage_           := nGetProcAddress(hUser , "LoadImageA"         )
_fpDeleteObject_        := nGetProcAddress(hUser , "DeleteObject"       )
_fpFillRect_            := nGetProcAddress(hUser , "FillRect"           )
_fpSetWindowLong_       := nGetProcAddress(hUser , "SetWindowLongA"     )
_fpGetWindowLong_       := nGetProcAddress(hUser , "GetWindowLongA"     )
_fpCallWindowProc_      := nGetProcAddress(hUser , "CallWindowProcA"    )
return
// ---------------------------------------------------------------------------
BEGIN STRUCTURE _XbpSubCargo_
   MEMBER LPXBASE oSelf
   MEMBER POINTER fpOldProc
   MEMBER HANDLE  hBrush
   MEMBER HWND    hRel
END STRUCTURE
// ---------------------------------------------------------------------------
BEGIN STRUCTURE Rect
   MEMBER LONG left
   MEMBER LONG top
   MEMBER LONG right
   MEMBER LONG bottom
END STRUCTURE
// ---------------------------------------------------------------------------
BEGIN STRUCTURE  NMHDR
    MEMBER HWND hwndFrom
    MEMBER UINT idFrom
    MEMBER UINT code
END STRUCTURE
// ---------------------------------------------------------------------------
BEGIN STRUCTURE NMCUSTOMDRAW
    MEMBER @ NMHDR hdr
    MEMBER DWORD dwDrawStage
    MEMBER HDC hdc
    MEMBER @ RECT rc
    MEMBER DWORD dwItemSpec
    MEMBER UINT  uItemState
    MEMBER LPARAM lItemlParam
END STRUCTURE
//-------------------------------------------------------------------------------------------------------------------------
BEGIN STRUCTURE NMTVCUSTOMDRAW
    MEMBER @ NMCUSTOMDRAW nmcd
    MEMBER LONG           clrText
    MEMBER LONG           clrTextBk
    MEMBER LONG           iLevel
END STRUCTURE
// ---------------------------------------------------------------------------
BEGIN STRUCTURE TVITEMEX
    MEMBER UINT    mask
    MEMBER HANDLE  hItem
    MEMBER UINT    state
    MEMBER UINT    stateMask
    MEMBER LPSTR   pszText
    MEMBER int     cchTextMax
    MEMBER int     iImage
    MEMBER int     iSelectedImage
    MEMBER int     cChildren
    MEMBER LPARAM  lParam
    MEMBER int     iIntegral
END STRUCTURE
// ---------------------------------------------------------------------------
CLASS CustomTree FROM XbpTreeView
EXPORTED:
       // --------------------------------------------------------------------
INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPP, lVisible )
       local oData := _XbpSubCargo_():New()
       local pData := 0
       local lHidden := !::visible
       local hParent
       local hBrush
       ::visible := .F.
       oData:_alloc_(.F. , @pData )
       ::XbpTreeView:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
       hParent := nFpCall(_fpGetAncestor_ , ::GetHWND() , GA_PARENT )
       oData:oSelf := Self
       oData:hRel  := hParent
       oData:fpOldProc := nFpCall(_fpGetWindowLong_, ::GetHWND() ,  GWL_WNDPROC )
       hBrush := nFpCall( _fpCreatePatternBrush_ , nFpCall( _fpLoadImage_ , 0 , "Test.bmp",0,0,0,0x90))
       oData:hBrush := hBrush
       nFpCall(_fpSetWindowLong_, ::GetHWND(),GWL_USERDATA, pData )
       nFpCall(_fpSetWindowLong_, ::GetHWND(),GWL_WNDPROC , _callback_MyTreeViewProc())
       // ----- SubclassTheParent
       oData := _XbpSubCargo_():New()
       oData:_alloc_(.F. , @pData )
       oData:oSelf  := oParent
       oData:fpOldProc := nFpCall(_fpGetWindowLong_, hParent ,  GWL_WNDPROC )
       oData:hBrush := hBrush
       oData:hRel   := ::GetHWND()
       nFpCall(_fpSetWindowLong_, hParent ,GWL_USERDATA, pData )
       nFpCall(_fpSetWindowLong_, hParent ,GWL_WNDPROC , _callback_MyDrawingAreaProc())
       // ----- t
       if( !lHidden ) ; ::Show() ; end

       return Self
       // --------------------------------------------------------------------
INLINE METHOD Destroy()
       local pData := nFpCall( _fpGetWindowLong_, ::GetHWND(),GWL_USERDATA)
       local oData
       local hParent
       if( pData != 0 )
          oData := _XbpSubCargo_():New()
          oData:_link_( pData , .F. )
          nFpCall( _fpSetWindowLong_, ::GetHWND(),GWL_WNDPROC , oData:fpOldProc )
          nFpCall( _fpSetWindowLong_, ::GetHWND(),GWL_USERDATA, 0 )
          oData:oSelf := NIL
          hParent := oData:hRel
          oData:_free_(.F.)
          // Restore Parent proc
          pData := nFpCall( _fpGetWindowLong_, hParent,GWL_USERDATA)
          oData:_link_( pData , .F. )
          nFpCall( _fpSetWindowLong_, hParent ,GWL_WNDPROC , oData:fpOldProc )
          nFpCall( _fpSetWindowLong_, hParent ,GWL_USERDATA, 0 )
          oData:oSelf := NIL
          nFpCall( _fpDeleteObject_, oData:hBrush )
          oData:_free_(.F.)

       end
       ::xbpSLE:destroy()
       return Self

       // --------------------------------------------------------------------
INLINE METHOD OnCustomDraw(hWnd,oh,od)
       local nStage := oh:nmcd:dwDrawStage
       local oRect,n,aRect,oItem  
       local nIndent
       
       if nStage == CDDS_PREPAINT
          return nOr( CDRF_NOTIFYITEMDRAW , CDRF_NOTIFYPOSTPAINT )
       elseif nStage == CDDS_ITEMPREPAINT
          oRect := Rect():New()
          oRect:_write_( U2Bin( oh:nmcd:dwItemSpec ) )
          nFpCall( _fpSendMessage_ , hWnd , TVM_GETITEMRECT,0,oRect )
          nFpCall( _fpFillRect_ , oh:nmcd:hdc , oRect , od:hBrush )
          nIndent := nFpCall( _fpSendMessage_ , hWnd , TVM_GETINDENT,0,0)
          nFpCall( _fpSetBkMode_ , oh:nmcd:hdc , 1 )
          nFpCall( _fpSetTextColor_ , oh:nmcd:hdc , 0 )
          oItem := TVITEMEX():New()
          oItem:pszText    := _xgrab(260)
          oItem:cchTextMax := 260
          oItem:mask       := nOr( TVIF_TEXT ,TVIF_STATE,TVIF_HANDLE,TVIF_CHILDREN)
          oItem:hItem      := oh:nmcd:dwItemSpec
          nFpCall( _fpSendMessage_ , hWnd , TVM_GETITEM,0,oItem )
          
          aRect := {oRect:left + 2 , oRect:top + 2 , (oRect:left + nIndent) - 2 , oRect:bottom - 2 }
          
          for n := 0  to oh:iLevel     
             if n == oh:iLevel     
                nFpCall( _fpDrawFrameControl_ , oh:nmcd:hdc , aRect , DFC_BUTTON , DFCS_BUTTONCHECK )
             end
             aRect[1] += nIndent + 4 ; aRect[3] += nIndent + 4
          next
          oRect:_zeromemory_()
          oRect:_write_( U2Bin( oh:nmcd:dwItemSpec ) )
          nFpCall( _fpSendMessage_ , hWnd , TVM_GETITEMRECT,1,oRect )
          nFpCall( _fpExtTextOut_ , oh:nmcd:hdc , oRect:left , oRect:top ,0 , 0,;
                   oItem:pszText, _xstrlen( oItem:pszText) , 0)
          _xfree( oItem:pszText )
          return CDRF_SKIPDEFAULT
       end
       return 0
       // --------------------------------------------------------------------
ENDCLASS
// ---------------------------------------------------------------------------
function MyTreeViewProc( hWnd , nMsg , wp , lp )
local oData := _XbpSubCargo_():New()
local aRect := {0,0,0,0}
oData:_link_( nFpCall( _fpGetWindowLong_, hWnd ,GWL_USERDATA) , .F. )

if( nMsg == WM_ERASEBKGND )
   nFpCall( _fpGetClientRect_ , hWnd , @aRect )
   nFpCall( _fpFillRect_ , wp , aRect , oData:hBrush  )
   return 1
end
return nFpCall( _fpCallWindowProc_ , oData:fpOldProc , hWnd , nMsg , wp , lp )
// ---------------------------------------------------------------------------
function MyDrawingAreaProc( hWnd , nMsg , wp , lp )
local oData := _XbpSubCargo_():New()
local hCtrl
local oh

oData:_link_( nFpCall( _fpGetWindowLong_, hWnd ,GWL_USERDATA) , .F. )
hCtrl := oData:hRel

if( nMsg == WM_NOTIFY )
   oh := NMHDR():New()
   oh:_link_( lp , .F. )
   if ( (oh:code ==  NM_CUSTOMDRAW) .and. (oh:hwndFrom == hCtrl ) )
      oh := oh:_scast_( NMTVCUSTOMDRAW() )
      oData := _XbpSubCargo_():New()
      oData:_link_( nFpCall( _fpGetWindowLong_, hCtrl,GWL_USERDATA) , .F. )
      return oData:oSelf:OnCustomDraw(hCtrl,oh,oData)
   end
end
return nFpCall( _fpCallWindowProc_ , oData:fpOldProc , hWnd , nMsg , wp , lp )
// ---------------------------------------------------------------------------
