
//------------------------------------------------------------
//  Project: Open Tools for Xbase++                          -
//  Repository : http://www.xbwin.com                        -
//  Author: Pablo Botella Navarro ( http://www.xbwin.com )   -
//------------------------------------------------------------
REQUEST ot4xb
#ifndef CRLF
#define CRLF              (Chr(13)+Chr(10))
#endif
#xcommand DEFAULT <uVar1> := <uVal1> => <uVar1> := iif( <uVar1> == NIL, <uVal1>, <uVar1> )
#xtranslate BYNAME <V> [, <VN> ]     => ::<V> := <V> [; ::<VN> := <VN> ]
#xtranslate BYNAME <V> DEFAULT <Val> => ::<V> := iif(<V> == NIL , <Val> , <V> )
#xtranslate BYNAME <V> IFNONIL =>  if <V> != NIL ; ::<V> := <V> ;  end
#define MAX(x,y)  ( iif( x > y , x , y) )
#define MIN(x,y)  ( iif( x < y , x , y) )
#xtranslate StrTrim(<n>)   =>  LTrim(Str(<n>))
//-------------------------------------------------------------------------------------------------------------------------
#ifdef OT4XB_DEBUG
#xtranslate ot4xb_SendFLog(<params,...>) => lSendLogStrFL( __FILE__ , __LINE__ , <params> )
#xtranslate ot4xb_SendLog(<params,...>)  => lSendLogStr( <params> )
#else
#xtranslate ot4xb_SendLog( <params,...>  )  =>
#xtranslate ot4xb_SendFLog( <params,...>  ) =>
#endif
//-------------------------------------------------------------------------------------------------------------------------
#define OT4XB_LOG_WND_CLASS  "11CBDBE2_0AF0_4713_B463_269FA6E2654B"
//-------------------------------------------------------------------------------------------------------------------------
#xtranslate GwstArrayNext( <o> ) => <o>:_link_( <o>:_addressof_() + <o>:_sizeof_()) 
#xtranslate GwstArrayPrev( <o> ) => <o>:_link_( <o>:_addressof_() + <o>:_sizeof_()) 
//-------------------------------------------------------------------------------------------------------------------------
#xtranslate GWSTSKIPBYTES( <n> ) => ooo:_GwstSkipBytes( <n> )
#xtranslate GWSTGETOFFSET() => ooo:_GwstGetOffset()
#xtranslate GWSTGETOFFSET( <n> ) => ooo:_GwstSetOffset( <n> )
#xtranslate GWSTALIGNNEXTMEMBER( <n> ) => ooo:_GwstAlignNextMember( <n> )
#xtranslate GWSTBACK() => ooo:_GwstBack()
#xtranslate GWSTPARENT( [ <p1> ] )  => ooo:_GwstParent( [ <p1>() ] )
#xtranslate ADDGWSTSTYLEMEMBERS() => ooo:AddGwstStyleMembers
//-----------------------------------------------------------------------------------------------------------------------
#xcommand BEGIN DYNAMIC CLASS <Tag> [ FROM <p1> [, <pN>] ] [<*more*>] => ;
          function <Tag>() ;
          ; local ooo ;
          ; local oClass := ClassObject(<(Tag)>);
          [;<more>] ;
          ; if oClass != NIL ;
          ; return oClass ;
          ; end ;
          ; ooo := TXbClass():New( <(Tag)>) ;
          [; ooo:Parent( <p1>() ) ];
          [; ooo:Parent( <pN>() )]
//-----------------------------------------------------------------------------------------------------------------------
#xcommand END DYNAMIC CLASS => oClass := ooo:Create() ; ooo:Destroy() ; return oClass
//-----------------------------------------------------------------------------------------------------------------------
#xcommand DYNAMIC VAR                <cName>  [FLAGS <nExtra> ]    => ooo:_Var(<(cName)> [, <nExtra> ])
#xcommand DYNAMIC CLASS VAR          <cName>  [FLAGS <nExtra> ]    => ooo:_ClassVar(<(cName)> [, <nExtra> ])
#xcommand DYNAMIC SHARED CLASS VAR   <cName>  [FLAGS <nExtra> ]    => ooo:_SharedClassVar(<(cName)> [, <nExtra> ])
//-----------------------------------------------------------------------------------------------------------------------
#xcommand DYNAMIC PROPERTY           <cName>  BLOCK <uBlock>       => ooo:_Property( <(cName)> , <uBlock> )
#xcommand DYNAMIC CLASS PROPERTY     <cName>  BLOCK <uBlock>       => ooo:_ClassProperty( <(cName)> , <uBlock> )
#xcommand DYNAMIC READONLY PROPERTY           <cName>  BLOCK <uBlock>       => ooo:_ROProperty( <(cName)> , <uBlock> )
#xcommand DYNAMIC READONLY CLASS PROPERTY     <cName>  BLOCK <uBlock>       => ooo:_ROClassProperty( <(cName)> , <uBlock> )
#xcommand DYNAMIC WRITEONLY PROPERTY           <cName>  BLOCK <uBlock>       => ooo:_WOProperty( <(cName)> , <uBlock> )
#xcommand DYNAMIC WRITEONLY CLASS PROPERTY     <cName>  BLOCK <uBlock>       => ooo:_WOClassProperty( <(cName)> , <uBlock> )
//-----------------------------------------------------------------------------------------------------------------------
#xcommand DYNAMIC  PROPERTY <cc>  READ <rr> WRITE <ww> => ;
                   ooo:_Property(<(cc)>, {|Self,v|iif( PCount() > 1 , <ww> , <rr> ) } )
                   
#xcommand DYNAMIC  CLASS PROPERTY <cc>  READ <rr> WRITE <ww> => ;
                   ooo:_ClassProperty(<(cc)>, {|Self,v|iif( PCount() > 1 , <ww> , <rr> ) } )
//-----------------------------------------------------------------------------------------------------------------------
#xcommand DYNAMIC  PROPERTY <cc>  READ <rr>  => ;
                   ooo:_ROProperty(<(cc)>, {|Self| <rr>  } )
                   
#xcommand DYNAMIC  CLASS PROPERTY <cc>  READ <rr> => ;
                   ooo:_ROClassProperty(<(cc)>, {|Self| <rr> } )
//-----------------------------------------------------------------------------------------------------------------------
#xcommand DYNAMIC  PROPERTY <cc>  WRITE <ww> => ;
                   ooo:_WOProperty(<(cc)>, {|Self,v| <ww> } )
                   
#xcommand DYNAMIC  CLASS PROPERTY <cc>  WRITE <ww> => ;
                   ooo:_WOClassProperty(<(cc)>, {|Self,v| <ww> } )
//-----------------------------------------------------------------------------------------------------------------------
#xcommand DYNAMIC PROPERTY                  <cName>  COMPILE <ss>  => ooo:_Property( <(cName)> , (&(<ss>))  )
#xcommand DYNAMIC CLASS PROPERTY            <cName>  COMPILE <ss>  => ooo:_ClassProperty( <(cName)> , (&(<ss>)) )
#xcommand DYNAMIC READONLY PROPERTY         <cName>  COMPILE <ss>  => ooo:_ROProperty( <(cName)> ,  (&(<ss>))  )
#xcommand DYNAMIC READONLY CLASS PROPERTY   <cName>  COMPILE <ss>  => ooo:_ROClassProperty( <(cName)> ,  (&(<ss>)) )
#xcommand DYNAMIC WRITEONLY PROPERTY        <cName>  COMPILE <ss>  => ooo:_WOProperty( <(cName)> ,  (&(<ss>))  )
#xcommand DYNAMIC WRITEONLY CLASS PROPERTY  <cName>  COMPILE <ss>  => ooo:_WOClassProperty( <(cName)> ,  (&(<ss>))  )
//-----------------------------------------------------------------------------------------------------------------------

#xcommand DYNAMIC PROPERTY                  <cName>  COMPILE <ss> INSERT <p1> [, <pN>]  => ;
          DYNAMIC PROPERTY                  <cName>  COMPILE cPrintf( <(ss)> ,<p1> [,<pN>])
#xcommand DYNAMIC CLASS PROPERTY            <cName>  COMPILE <ss> INSERT <p1> [, <pN>]  => ;
          DYNAMIC CLASS PROPERTY            <cName>  COMPILE cPrintf( <(ss)> ,<p1> [,<pN>])
#xcommand DYNAMIC READONLY PROPERTY         <cName>  COMPILE <ss> INSERT <p1> [, <pN>]  => ;
          DYNAMIC READONLY PROPERTY         <cName>  COMPILE cPrintf( <(ss)> ,<p1> [,<pN>])
#xcommand DYNAMIC READONLY CLASS PROPERTY   <cName>  COMPILE <ss> INSERT <p1> [, <pN>]  => ;
          DYNAMIC READONLY CLASS PROPERTY   <cName>  COMPILE cPrintf( <(ss)> ,<p1> [,<pN>])
#xcommand DYNAMIC WRITEONLY PROPERTY        <cName>  COMPILE <ss> INSERT <p1> [, <pN>]  => ;
          DYNAMIC WRITEONLY PROPERTY        <cName>  COMPILE cPrintf( <(ss)> ,<p1> [,<pN>])
#xcommand DYNAMIC WRITEONLY CLASS PROPERTY  <cName>  COMPILE <ss> INSERT <p1> [, <pN>]  => ;
          DYNAMIC WRITEONLY CLASS PROPERTY  <cName>  COMPILE cPrintf( <(ss)> ,<p1> [,<pN>])
//-----------------------------------------------------------------------------------------------------------------------

#xcommand DYNAMIC  PROPERTY <cc>  COMPILE READ <rr> WRITE <ww> => ;
          DYNAMIC  PROPERTY <cc>  COMPILE "{|Self,v|iif( PCount() > 1 ," + <ww> +"," +  <rr> +")}"
                   
#xcommand DYNAMIC  CLASS PROPERTY <cc>  COMPILE READ <rr> WRITE <ww> => ;
          DYNAMIC  CLASS PROPERTY <cc>  COMPILE "{|Self,v|iif( PCount() > 1 ," + <ww> +"," +  <rr> +")}"

#xcommand DYNAMIC  PROPERTY <cc>  COMPILE READ <rr>  => ;
          DYNAMIC  READONLY PROPERTY <cc>  COMPILE "{|Self|" + <rr> +"}"
                   
#xcommand DYNAMIC  CLASS PROPERTY <cc>  COMPILE READ <rr> => ;
          DYNAMIC  READONLY CLASS PROPERTY <cc>  COMPILE "{|Self|" + <rr> +"}"

#xcommand DYNAMIC  PROPERTY <cc>  COMPILE WRITE <ww> => ;
          DYNAMIC  WRITEONLY PROPERTY <cc>  COMPILE "{|Self,v|" + <ww> +"}"
                   
#xcommand DYNAMIC  CLASS PROPERTY <cc>  COMPILE WRITE <ww> => ;
          DYNAMIC  WRITEONLY CLASS PROPERTY <cc>  COMPILE "{|Self,v|" + <ww> +"}"

//-----------------------------------------------------------------------------------------------------------------------


#xcommand DYNAMIC  PROPERTY <cc>  COMPILE READ <rr> WRITE <ww> INSERT <p1> [, <pN>] => ;
          DYNAMIC  PROPERTY <cc>  COMPILE "{|Self,v|iif( PCount() > 1 ," + <ww> +"," +  <rr> +")}" ;
          INSERT <p1> [, <pN>] 
                   
#xcommand DYNAMIC  CLASS PROPERTY <cc>  COMPILE READ <rr> WRITE <ww> INSERT <p1> [, <pN>] => ;
          DYNAMIC  CLASS PROPERTY <cc>  COMPILE "{|Self,v|iif( PCount() > 1 ," + <ww> +"," +  <rr> +")}" ;
          INSERT <p1> [, <pN>] 

#xcommand DYNAMIC  PROPERTY <cc>  COMPILE READ <rr>  INSERT <p1> [, <pN>]  => ;
          DYNAMIC  READONLY PROPERTY <cc>  COMPILE "{|Self|" + <rr> +"}" INSERT <p1> [, <pN>] 
                   
#xcommand DYNAMIC  CLASS PROPERTY <cc>  COMPILE READ <rr> INSERT <p1> [, <pN>]  => ;
          DYNAMIC  READONLY CLASS PROPERTY <cc>  COMPILE "{|Self|" + <rr> +"}" INSERT <p1> [, <pN>] 

#xcommand DYNAMIC  PROPERTY <cc>  COMPILE WRITE <ww> INSERT <p1> [, <pN>]  => ;
          DYNAMIC  WRITEONLY PROPERTY <cc>  COMPILE "{|Self,v|" + <ww> +"}" INSERT <p1> [, <pN>] 
                   
#xcommand DYNAMIC  CLASS PROPERTY <cc>  COMPILE WRITE <ww> INSERT <p1> [, <pN>]  => ;
          DYNAMIC  WRITEONLY CLASS PROPERTY <cc>  COMPILE "{|Self,v|" + <ww> +"}" INSERT <p1> [, <pN>] 
//-----------------------------------------------------------------------------------------------------------------------

#xcommand DYNAMIC PROPERTY <cc>  IS MASK <mask> OF <var> => ;
          DYNAMIC  PROPERTY <cc>  ;
          READ lAnd( ::<var> , <mask> ) ;
          WRITE (  ::<var> := iif(v,nOr( ::<var>,<mask>),nAndNot(::<var>,<mask>)) )

#xcommand DYNAMIC PROPERTY <cc>  IS MASK <mask> OF <var> READONLY => ;
          DYNAMIC  PROPERTY <cc>  ;
          READ lAnd( ::<var> , <mask> ) 

#xcommand DYNAMIC PROPERTY <cc>  IS CONSTANT <val> => DYNAMIC  PROPERTY <cc> READ <val>
//-------------------------------------------------------------------------------------------------------------------------
#xcommand DYNAMIC CLASS PROPERTY <cc>  IS MASK <mask> OF <var> => ;
          DYNAMIC  CLASS PROPERTY <cc>  ;
          READ lAnd( ::<var> , <mask> ) ;
          WRITE (  ::<var> := iif(v,nOr( ::<var>,<mask>),nAndNot(::<var>,<mask>)) )

#xcommand DYNAMIC CLASS PROPERTY <cc>  IS MASK <mask> OF <var> READONLY => ;
          DYNAMIC  CLASS PROPERTY <cc>  ;
          READ lAnd( ::<var> , <mask> ) 

#xcommand DYNAMIC CLASS PROPERTY <cc>  IS CONSTANT <val> => DYNAMIC  CLASS PROPERTY <cc> READ <val>
//-----------------------------------------------------------------------------------------------------------------------
#xcommand DYNAMIC METHOD             <cName>  BLOCK <uBlock>       => ooo:_Method( <(cName)> , <uBlock> )

#xcommand DYNAMIC METHOD <cc>  COMPILE <ss>   => ;
          ooo:_Method( <(cc)> , (&( <(ss)>)) )

#xcommand DYNAMIC METHOD <cc>  COMPILE <ss> INSERT <p1> [, <pN>]  => ;
          ooo:_Method( <(cc)> , (&( cPrintf( <(ss)> ,<p1> [,<pN>]))) )                                        
          
#xcommand DYNAMIC CLASS METHOD       <cName>  BLOCK <uBlock>       => ooo:_ClassMethod( <(cName)> , <uBlock> )

#xcommand DYNAMIC CLASS METHOD <cc>  COMPILE <ss>   => ;
          ooo:_ClassMethod( <(cc)> , (&( <(ss)>)) )

#xcommand DYNAMIC CLASS METHOD <cc>  COMPILE <ss> INSERT <p1> [, <pN>]  => ;
          ooo:_ClassMethod( <(cc)> , (&( cPrintf( <(ss)> ,<p1> [,<pN>]))) )

//-----------------------------------------------------------------------------------------------------------------------
#xcommand BEGIN STRUCTURE <Tag> [EXTENDING <super> ]  [<*more*>] => ;
          BEGIN DYNAMIC CLASS <Tag> [<more>] ;
          ; GWSTPARENT( [ <super>() ] )
//-----------------------------------------------------------------------------------------------------------------------
#xcommand END STRUCTURE => END DYNAMIC CLASS
//-------------------------------------------------------------------------------------------------------------------------
#xcommand MEMBER @ <cls> <m> => ooo:_Child( <(m)> , <cls>() )
//-------------------------------------------------------------------------------------------------------------------------
#xcommand BEGIN UNION => ooo:_GwstBeginUnion()
#xcommand END UNION   => ooo:_GwstEndUnion()
//-----------------------------------------------------------------------------------------------------------------------
#xcommand MEMBER DWORDNET       <m> => ooo:_Member_DWordNet( <(m)> )
#xcommand MEMBER WORDNET        <m> => ooo:_Member_WordNet( <(m)> )
//-------------------------------------------------------------------------------------------------------------------------
#xcommand MEMBER BOOL           <m> => ooo:_Member_Bool( <(m)> )
#xcommand MEMBER BYTE           <m> => ooo:_Member_Byte( <(m)> )
#xcommand MEMBER WORD           <m> => ooo:_Member_Word( <(m)> )
#xcommand MEMBER INT16          <m> => ooo:_Member_Int16( <(m)> )
#xcommand MEMBER SHORT          <m> => ooo:_Member_Short( <(m)> )
#xcommand MEMBER DWORD          <m> => ooo:_Member_DWord( <(m)> )
#xcommand MEMBER ULONG          <m> => ooo:_Member_ULong( <(m)> )
#xcommand MEMBER LONG           <m> => ooo:_Member_Long( <(m)> )
#xcommand MEMBER UINT           <m> => ooo:_Member_UInt( <(m)> )
#xcommand MEMBER INT            <m> => ooo:_Member_Int( <(m)> )
#xcommand MEMBER INT32          <m> => ooo:_Member_Int32( <(m)> )
#xcommand MEMBER LPARAM         <m> => ooo:_Member_LParam( <(m)> )
#xcommand MEMBER WPARAM         <m> => ooo:_Member_WParam( <(m)> )
#xcommand MEMBER POINTER        <m> => ooo:_Member_Pointer( <(m)> )
#xcommand MEMBER POINTER32      <m> => ooo:_Member_Pointer32( <(m)> )
#xcommand MEMBER HANDLE         <m> => ooo:_Member_Handle( <(m)> )
#xcommand MEMBER HWND           <m> => ooo:_Member_HWND( <(m)> )
#xcommand MEMBER HDC            <m> => ooo:_Member_HDC( <(m)> )
#xcommand MEMBER PCLIPVAR       <m> => ooo:_Member_Xbase( <(m)> )
#xcommand MEMBER PXBASEVAR      <m> => ooo:_Member_Xbase( <(m)> )
#xcommand MEMBER CODEBLOCK      <m> => ooo:_Member_Xbase( <(m)> )
#xcommand MEMBER LPXBASE        <m> => ooo:_Member_Xbase( <(m)> )
#xcommand MEMBER DWORD64        <m> => ooo:_Member_DWord64( <(m)> )
#xcommand MEMBER DOUBLE         <m> => ooo:_Member_Double( <(m)> )
#xcommand MEMBER FLOAT          <m> => ooo:_Member_Float( <(m)> )
#xcommand MEMBER LPSTR          <m> => ooo:_Member_LPSTR( <(m)> )
#xcommand MEMBER DYNSZ          <m> => ooo:_Member_DYNSZ( <(m)> )
//-------------------------------------------------------------------------------------------------------------------------
#xcommand MEMBER BINSTR  <m>  SIZE <n> => ooo:_Member_BINSTR( <(m)> , <n>)
#xcommand MEMBER SZSTR   <m>  SIZE <n> => ooo:_Member_SZSTR( <(m)> , <n>)
//-------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------------------
#define MAKEINTRESOURCE(n)    ( nAnd(n,0xFFFF) )
#define MAKEINTATOM(n)        ( nAnd(n,0xFFFF) )
//-------------------------------------------------------------------------------------------------------------------------
// Constants for nGetDriveType()
#ifndef ___GETDRIVETYPE___
#define ___GETDRIVETYPE___
#define DRIVE_UNKNOWN     0
#define DRIVE_NO_ROOT_DIR 1
#define DRIVE_REMOVABLE   2
#define DRIVE_FIXED       3
#define DRIVE_REMOTE      4
#define DRIVE_CDROM       5
#define DRIVE_RAMDISK     6
#endif
//-------------------------------------------------------------------------------------------------------------------------
#xcommand PROPERTY <name>  IS MASK <mask> OF <var> => ;
          INLINE ACCESS ASSIGN METHOD <name>(bOnOff) ;
          ; if( PCount() > 0 ) ;
          ;   if( bOnOff ) ;
          ;      ::<var> := nOr( ::<var> , <mask> ) ;
          ;   else ;
          ;      ::<var> := nAndNot( ::<var> , <mask> )  ;
          ;   end ;
          ;   return bOnOff ;
          ;end ;
          ;return lAnd( ::<var> , <mask> )
//-------------------------------------------------------------------------------------------------------------------------
#xcommand PROPERTY <name>  IS MASK <mask> OF <var> READONLY => ;
          INLINE ACCESS METHOD <name>() ;
          ;return lAnd( ::<var> , <mask> )
//-------------------------------------------------------------------------------------------------------------------------
#xcommand PROPERTY <name>  IS CONSTANT <val> => ;
          INLINE ACCESS METHOD <name>() ;
          ; return <val>
//-------------------------------------------------------------------------------------------------------------------------
#xcommand CLASS PROPERTY <name>  IS MASK <mask> OF <var> => ;
          INLINE ACCESS ASSIGN CLASS METHOD <name>(bOnOff) ;
          ; if( PCount() > 0 ) ;
          ;   if( bOnOff ) ;
          ;      ::<var> := nOr( ::<var> , <mask> ) ;
          ;   else ;
          ;      ::<var> := nAndNot( ::<var> , <mask> )  ;
          ;   end ;
          ;   return bOnOff ;
          ;end ;
          ;return lAnd( ::<var> , <mask> )
//-------------------------------------------------------------------------------------------------------------------------
#xcommand CLASS PROPERTY <name>  IS MASK <mask> OF <var> READONLY => ;
          INLINE ACCESS CLASS METHOD <name>() ;
          ;return lAnd( ::<var> , <mask> )
//-------------------------------------------------------------------------------------------------------------------------
#xcommand CLASS PROPERTY <name>  IS CONSTANT <val> => ;
          INLINE ACCESS CLASS METHOD <name>() ;
          ; return <val>
//-------------------------------------------------------------------------------------------------------------------------
#xcommand BEGIN VARLEN STRUCTURE   <cn> => ;
          BEGIN STRUCTURE <cn> local _cgb_ , _cpb_ ;
          ; _cgb_ := "{|s|s:_read_() " ;
          ; _cpb_ := "{|s,v,nn| nn := %u,s:_write_(v,0,nn),"


#xcommand END VARLEN STRUCTURE => ;
            _cgb_ += "}" ;
          ; _cpb_ += "s}" ;
          ; DYNAMIC METHOD Get COMPILE _cgb_ ;
          ; DYNAMIC METHOD Put COMPILE _cpb_ INSERT ooo:GwstGetOffset() ;
          ; END STRUCTURE

#xcommand VARLEN EXTRA MEMBER <cc> SIZE TO <sz> =>  ;
            DYNAMIC  VAR   __<cc> ;
          ; DYNAMIC  PROPERTY <cc> ;
                     READ iif(::__<cc> == NIL,"", ::__<cc>) ;
                     WRITE ( ::<sz> := Len(v) , ::__<cc> := v ) ;
          ; _cgb_ += " + s:" + <(cc)> ;
          ; _cpb_ += "s:__" + <(cc)> + " := PeekStr(@v,@nn,s:" + <(sz)> + "),"

//-----------------------------------------------------------------------------------------------------------------------
